"use strict";

exports.__esModule = true;
exports.parse = parse;
// istanbul ignore next

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _state = require("./state");

var _options = require("./options");

require("./parseutil");

require("./statement");

require("./lval");

require("./expression");

require("./node");

require("./location");

require("./lookahead");

var _tokentype = require("./tokentype");

require("./tokenize");

require("./tokencontext");

require("./comments");

var _pluginsFlow = require("./plugins/flow");

var _pluginsFlow2 = _interopRequireDefault(_pluginsFlow);

var _pluginsJsx = require("./plugins/jsx");

var _pluginsJsx2 = _interopRequireDefault(_pluginsJsx);

_state.plugins.flow = _pluginsFlow2["default"];
_state.plugins.jsx = _pluginsJsx2["default"];

function parse(input, options) {
  return new _state.Parser(_options.getOptions(options), input).parse();
}

exports.tokTypes = _tokentype.types;